#pragma once
#include <Windows.h>
#include <string>
#include <cstdint>
#include <boost/noncopyable.hpp>
#include "configuration.h"

class dialogs : boost::noncopyable
{
public:
	static void show_settings_dialog(HWND owner);
	static void show_about_dialog(HWND owner);

private:
	dialogs();

	enum button_type
	{
		button_add,
		button_remove
	};

	static void refresh_proxy_settings(HWND win, bool auto_proxy, bool no_proxy, const std::wstring& proxy,
		bool use_proxy_auth, const std::wstring& proxy_login, const std::wstring& proxy_password);
	static void toggle_proxy_controls(HWND win, bool enable);
	static void toggle_proxy_auth_controls(HWND win, bool enable);
	static void toggle_preview_contains_controls(HWND win, bool enable);
	static void toggle_preview_does_not_contain_controls(HWND win, bool enable);
	static void init_settings(HWND hWnd);
	static void fill_combobox(HWND hWnd, uint32_t id, const std::string& property_name);
	static const std::wstring get_combobox_string(HWND hWnd, uint32_t id, int32_t index);
	static bool combobox_contains_string(HWND hWnd, uint32_t id, const std::wstring& value, int32_t* index);
	static void update_filter(HWND hWnd, uint32_t combo_id, uint32_t button_id, bool on_select);
	static const std::wstring get_combo_text(HWND hWnd, uint32_t combo_id);
	static const std::string get_field_value(HWND win, uint32_t id);
	static const configuration::string_set get_combobox_strings(HWND hWnd, uint32_t id);

	static INT_PTR WINAPI settings_dialog(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam);
};
