#pragma once
#include <string>
#include <cstdint>
#include <boost/system/error_code.hpp>

class double_click_monitor_impl;
class double_click_monitor : boost::noncopyable
{
public:
	double_click_monitor();

	~double_click_monitor();

	void run();

	void reset_timer(uint32_t duration, const std::wstring& url, int32_t x, int32_t y);
	
private:
	struct url_info
	{
		url_info();
		url_info(const std::wstring& page_url, int32_t mousex, int32_t mousey);

		int32_t x, y;
		std::wstring url;
	};

private:
	double_click_monitor_impl* impl_;

	static const uint32_t default_loop_timeout = 60;

	void on_timer(const url_info& info, const boost::system::error_code& e);
	void on_reset_timer(uint32_t duration, const url_info& info);
};
